]> Git Repo - binutils.git/blame_incremental - configure.in
* gas/mips/itbl-test.c: Add copyright message and fix indentation.
[binutils.git] / configure.in
... / ...
CommitLineData
1#! /bin/bash
2##############################################################################
3
4## This file is a shell script fragment that supplies the information
5## necessary to tailor a template configure script into the configure
6## script appropriate for this directory. For more information, check
7## any existing configure script.
8
9## Be warned, there are two types of configure.in files. There are those
10## used by Autoconf, which are macros which are expanded into a configure
11## script by autoconf. The other sort, of which this is one, is executed
12## by Cygnus configure.
13
14## For more information on these two systems, check out the documentation
15## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17# Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18#
19# This file is free software; you can redistribute it and/or modify it
20# under the terms of the GNU General Public License as published by
21# the Free Software Foundation; either version 2 of the License, or
22# (at your option) any later version.
23#
24# This program is distributed in the hope that it will be useful, but
25# WITHOUT ANY WARRANTY; without even the implied warranty of
26# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27# General Public License for more details.
28#
29# You should have received a copy of the GNU General Public License
30# along with this program; if not, write to the Free Software
31# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33##############################################################################
34
35### To add a new directory to the tree, first choose whether it is a target
36### or a host dependent tool. Then put it into the appropriate list
37### (library or tools, host or target), doing a dependency sort. For
38### example, gdb requires that byacc (or bison) be built first, so it is in
39### the ${host_tools} list after byacc and bison.
40
41
42# these libraries are used by various programs built for the host environment
43#
44host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48fi
49
50# these tools are built for the host environment
51#
52host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils"
53
54
55# these libraries are built for the target environment, and are built after
56# the host libraries and the host tools (which may be a cross compiler)
57#
58target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61# these tools are built using the target libs, and are intended to run only
62# in the target environment
63#
64# note: any program that *uses* libraries that are in the "target_libs"
65# list belongs in this list. those programs are also very likely
66# candidates for the "native_only" list which follows
67#
68target_tools="target-examples target-groff"
69
70################################################################################
71
72## These two lists are of directories that are to be removed from the
73## ${configdirs} list for either cross-compilations or for native-
74## compilations. For example, it doesn't make that much sense to
75## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76## a native environment.
77
78# directories to be built in the native environment only
79#
80# This must be a single line because of the way it is searched by grep in
81# the code below.
82native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84# directories to be built in a cross environment only
85#
86cross_only="target-libiberty target-libgloss target-newlib"
87
88## All tools belong in one of the four categories, and are assigned above
89## We assign ${configdirs} this way to remove all embedded newlines. This
90## is important because configure will choke if they ever get through.
91## ${configdirs} is directories we build using the host tools.
92## ${target_configdirs} is directories we build using the target tools.
93#
94configdirs=`echo ${host_libs} ${host_tools}`
95target_configdirs=`echo ${target_libs} ${target_tools}`
96
97################################################################################
98
99srctrigger=move-if-change
100srcname="gnu development package"
101
102# This gets set non-empty for some net releases of packages.
103appdirs=""
104
105# per-host:
106
107# Work in distributions that contain no compiler tools, like Autoconf.
108if [ -d ${srcdir}/config ]; then
109case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
134 *-windows*) host_makefile_frag=config/mh-windows ;;
135 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
136 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
137 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
138 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
139 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
140 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
141 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
142 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
143 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
144 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
145esac
146fi
147
148# If we aren't going to be using gcc, see if we can extract a definition
149# of CC from the fragment.
150if [ -z "${CC}" -a "${build}" = "${host}" ]; then
151 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
152 found=
153 for dir in $PATH; do
154 test -z "$dir" && dir=.
155 if test -f $dir/gcc; then
156 found=yes
157 break
158 fi
159 done
160 IFS="$save_ifs"
161 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
162 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
163 if [ -n "${xx}" ] ; then
164 CC=$xx
165 fi
166 fi
167fi
168
169# We default to --with-shared on platforms where -fpic is meaningless.
170# Well, we don't yet, but we will.
171if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 alpha-*-linux*) enable_shared=yes ;;
175 mips-sgi-irix5*) enable_shared=yes ;;
176 *) enable_shared=no ;;
177 esac
178fi
179
180case "${enable_shared}" in
181 yes) shared=yes ;;
182 no) shared=no ;;
183 "") shared=no ;;
184 *) shared=yes ;;
185esac
186
187if [ x${shared} = xyes ]; then
188 waugh=
189 case "${host}" in
190 hppa*) waugh=config/mh-papic ;;
191 i[3456]86-*) waugh=config/mh-x86pic ;;
192 sparc64-*) waugh=config/mh-sparcpic ;;
193 *) waugh=config/mh-${host_cpu}pic ;;
194 esac
195 if [ -f ${srcdir}/${waugh} ]; then
196 if [ -n "${host_makefile_frag}" ] ; then
197 cat ${srcdir}/${host_makefile_frag} > mh-frag
198 cat ${srcdir}/${waugh} >> mh-frag
199 host_makefile_frag=mh-frag
200 else
201 host_makefile_frag=${waugh}
202 fi
203 fi
204fi
205
206# per-target:
207
208case "${target}" in
209 v810*) target_makefile_frag=config/mt-v810 ;;
210 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
211 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
212esac
213
214skipdirs=
215gasdir=gas
216use_gnu_ld=
217use_gnu_as=
218
219# some tools are so dependent upon X11 that if we're not building with X,
220# it's not even worth trying to configure, much less build, that tool.
221
222case ${with_x} in
223 yes | "") # the default value for this tree is that X11 is available
224 ;;
225 no)
226 skipdirs="${skipdirs} tk gash"
227 ;;
228 *)
229 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
230 ;;
231esac
232
233# Some tools are only suitable for building in a "native" situation.
234# Those are added when we have a host==target configuration. For cross
235# toolchains, we add some directories that should only be useful in a
236# cross-compiler.
237
238is_cross_compiler=
239
240if [ x"${host}" = x"${target}" ] ; then
241 # when doing a native toolchain, don't build the targets
242 # that are in the 'cross only' list
243 skipdirs="${skipdirs} ${cross_only}"
244 is_cross_compiler=no
245 target_subdir=.
246else
247 # similarly, don't build the targets in the 'native only'
248 # list when building a cross compiler
249 skipdirs="${skipdirs} ${native_only}"
250 is_cross_compiler=yes
251 target_subdir=${target_alias}
252 if [ ! -d ${target_subdir} ] ; then
253 if mkdir ${target_subdir} ; then true
254 else
255 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
256 exit 1
257 fi
258 fi
259fi
260
261copy_dirs=
262
263# Handle --with-headers=XXX. The contents of the named directory are
264# copied to $(tooldir)/sys-include.
265if [ x"${with_headers}" != x ]; then
266 if [ x${is_cross_compiler} = xno ]; then
267 echo 1>&2 '***' --with-headers is only supported when cross compiling
268 exit 1
269 fi
270 case "${exec_prefixoption}" in
271 "") x=${prefix} ;;
272 *) x=${exec_prefix} ;;
273 esac
274 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
275fi
276
277# Handle --with-libs=XXX. Multiple directories are permitted. The
278# contents are copied to $(tooldir)/lib.
279if [ x"${with_libs}" != x ]; then
280 if [ x${is_cross_compiler} = xno ]; then
281 echo 1>&2 '***' --with-libs is only supported when cross compiling
282 exit 1
283 fi
284 # Copy the libraries in reverse order, so that files in the first named
285 # library override files in subsequent libraries.
286 case "${exec_prefixoption}" in
287 "") x=${prefix} ;;
288 *) x=${exec_prefix} ;;
289 esac
290 for l in ${with_libs}; do
291 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
292 done
293fi
294
295# If both --with-headers and --with-libs are specified, default to
296# --without-newlib.
297if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
298 if [ x"${with_newlib}" = x ]; then
299 with_newlib=no
300 fi
301fi
302
303# Recognize --with-newlib/--without-newlib.
304if [ x${with_newlib} = xno ]; then
305 skipdirs="${skipdirs} target-newlib"
306elif [ x${with_newlib} = xyes ]; then
307 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
308fi
309
310# Default to using --with-stabs for certain targets.
311if [ x${with_stabs} = x ]; then
312 case "${target}" in
313 mips*-*-irix6*)
314 ;;
315 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
316 with_stabs=yes;
317 withoptions="${withoptions} --with-stabs"
318 ;;
319 esac
320fi
321
322# Handle ${copy_dirs}
323set fnord ${copy_dirs}
324shift
325while [ $# != 0 ]; do
326 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
327 :
328 else
329 echo Copying $1 to $2
330
331 # Use the install script to create the directory and all required
332 # parent directories.
333 if [ -d $2 ]; then
334 :
335 else
336 echo >config.temp
337 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
338 fi
339
340 # Copy the directory, assuming we have tar.
341 # FIXME: Should we use B in the second tar? Not all systems support it.
342 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
343
344 # It is the responsibility of the user to correctly adjust all
345 # symlinks. If somebody can figure out how to handle them correctly
346 # here, feel free to add the code.
347
348 echo $1 > $2/COPIED
349 fi
350 shift; shift
351done
352
353# Configure extra directories which are host specific
354
355case "${host}" in
356 i[3456]86-*-go32*)
357 configdirs="$configdirs dosrel" ;;
358 *-cygwin32*)
359 configdirs="$configdirs dosrel" ;;
360esac
361
362# Remove more programs from consideration, based on the host or
363# target this usually means that a port of the program doesn't
364# exist yet.
365
366noconfigdirs=""
367
368case "${host}" in
369 i[3456]86-*-vsta)
370 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
371 ;;
372 i[3456]86-*-go32)
373 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 *-*-cygwin32)
376 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
377 ;;
378 *-*-windows*)
379# This is only used to build WinGDB...
380 configdirs="bfd gdb libiberty opcodes readline sim"
381 target_configdirs=
382 ;;
383 ppc*-*-pe)
384 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
385 ;;
386esac
387
388
389case "${target}" in
390 *-*-netware)
391 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
392 ;;
393 *-*-vxworks*)
394 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
395 ;;
396 alpha-dec-osf*)
397 # ld works, but does not support shared libraries. emacs doesn't
398 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
399 # gas doesn't generate exception information.
400 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
401 ;;
402 alpha*-*-*vms*)
403 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
404 ;;
405 alpha*-*-*)
406 # newlib is not 64 bit ready
407 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
408 ;;
409# start-sanitize-arc
410 arc-*-*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413# end-sanitize-arc
414 arm-*-pe*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 arm-*-coff*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-riscix*)
421 noconfigdirs="$noconfigdirs ld target-libgloss"
422 ;;
423# start-sanitize-d10v
424 d10v-*-*)
425 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
426 ;;
427# end-sanitize-d10v
428 h8300*-*-* | \
429 h8500-*-*)
430 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
431 ;;
432 hppa*-*-*elf* | \
433 hppa*-*-lites*)
434 # Do configure ld/binutils/gas for this case.
435 ;;
436 hppa*-*-*)
437 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
438 # cc is gcc, and on any system a user should be able to link cc to
439 # whatever they want. FIXME, emacs emacs19).
440 case "${CC}" in
441 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
442 *) ;;
443 esac
444 noconfigdirs="$noconfigdirs ld shellutils"
445 ;;
446 i[3456]86-*-go32)
447 # but don't build gdb
448 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
449 ;;
450 *-*-cygwin32)
451 target_configdirs="$target_configdirs target-winsup"
452 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
453 # always build newlib.
454 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
455
456 # Can't build gdb for cygwin32 if not native.
457 case "${host}" in
458 *-*-cygwin32) ;; # keep gdb
459 *) noconfigdirs="$noconfigdirs gdb"
460 esac
461 ;;
462 i[3456]86-*-pe)
463 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
464 ;;
465 i[3456]86-*-sco3.2v5*)
466 # The linker does not yet know about weak symbols in COFF,
467 # and is not configured to handle mixed ELF and COFF.
468 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
469 ;;
470 i[3456]86-*-sco*)
471 noconfigdirs="$noconfigdirs gprof target-libgloss"
472 ;;
473 i[3456]86-*-solaris2*)
474 # The linker does static linking correctly, but the Solaris C library
475 # has bugs such that some important functions won't work when statically
476 # linked. (See man pages for getpwuid, for example.)
477 noconfigdirs="$noconfigdirs ld target-libgloss"
478 ;;
479 i[3456]86-*-sysv4*)
480 # The SYSV4 C compiler doesn't handle Emacs correctly
481 case "${CC}" in
482 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
483 *) ;;
484 esac
485 # but that's okay since emacs doesn't work anyway
486 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
487 ;;
488 mn10200-*-*)
489 noconfigdirs="$noconfigdirs target-libgloss"
490 ;;
491 mn10300-*-*)
492 noconfigdirs="$noconfigdirs target-libgloss"
493 ;;
494 powerpc-*-aix*)
495 # copied from rs6000-*-* entry
496 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
497 # This is needed until gcc and ld are fixed to work together.
498 use_gnu_ld=no
499 ;;
500 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
501 target_configdirs="$target_configdirs target-winsup"
502 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
503 # always build newlib.
504 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
505 ;;
506 # This is temporary until we can link against shared libraries
507 powerpcle-*-solaris*)
508 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
509 ;;
510 rs6000-*-lynxos*)
511 # The CVS server code doesn't work on the RS/6000
512 # Newlib makes problems for libg++ in crosses.
513 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
514 ;;
515 rs6000-*-aix*)
516 noconfigdirs="$noconfigdirs gprof"
517 # This is needed until gcc and ld are fixed to work together.
518 use_gnu_ld=no
519 ;;
520 rs6000-*-*)
521 noconfigdirs="$noconfigdirs gprof"
522 ;;
523 m68k-apollo-*)
524 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
525 ;;
526 mips*-*-irix5*)
527 # The GNU linker does not support shared libraries.
528 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
529 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
530 ;;
531 mips*-*-irix6*)
532 # The GNU linker does not support shared libraries.
533 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
534 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
535 ;;
536 mips*-dec-bsd*)
537 noconfigdirs="$noconfigdirs gprof target-libgloss"
538 ;;
539 mips*-*-bsd*)
540 noconfigdirs="$noconfigdirs gprof target-libgloss"
541 ;;
542 mips*-*-*)
543 noconfigdirs="$noconfigdirs gprof"
544 ;;
545 romp-*-*)
546 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
547 ;;
548 sh-*-*)
549 case "${host}" in
550 i[3456]86-*-vsta) ;; # don't add gprof back in
551 i[3456]86-*-go32) ;; # don't add gprof back in
552 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
553 esac
554 noconfigdirs="$noconfigdirs target-libgloss"
555 ;;
556 sparc-*-sunos4*)
557 if [ x${is_cross_compiler} != xno ] ; then
558 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
559 else
560 use_gnu_ld=no
561 fi
562 ;;
563# start-sanitize-tic80
564 tic80-*-*)
565 noconfigdirs="$noconfigdirs gcc gdb ld target-libio target-libg++ target-libstdc++ target-libgloss"
566 ;;
567# end-sanitize-tic80
568 v810-*-*)
569 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
570 ;;
571# start-sanitize-v850
572 v850-*-*)
573 noconfigdirs="$noconfigdirs target-libgloss"
574 ;;
575# end-sanitize-v850
576 vax-*-vms)
577 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
578 ;;
579 vax-*-*)
580 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
581 ;;
582 *-*-lynxos*)
583 # Newlib makes problems for libg++ in crosses.
584 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
585 ;;
586 *-*-macos* | \
587 *-*-mpw*)
588 # Macs want a resource compiler.
589 configdirs="$configdirs grez"
590 ;;
591esac
592
593# targets that need a second pass
594case "${target}" in
595 *-gm-magic*)
596 noconfigdirs="$noconfigdirs target-libgloss"
597 ;;
598esac
599
600# If we aren't building newlib, then don't build libgloss, since libgloss
601# depends upon some newlib header files.
602case "${noconfigdirs}" in
603 *target-libgloss*) ;;
604 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
605esac
606
607# If we are building a Canadian Cross, discard tools that can not be built
608# using a cross compiler. FIXME: These tools should be fixed.
609if [ "${build}" != "${host}" ]; then
610 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
611fi
612
613# Make sure we don't let GNU ld be added if we didn't want it.
614if [ x$with_gnu_ld = xno ]; then
615 use_gnu_ld=no
616 noconfigdirs="$noconfigdirs ld"
617fi
618
619# Make sure we don't let GNU as be added if we didn't want it.
620if [ x$with_gnu_as = xno ]; then
621 use_gnu_as=no
622 noconfigdirs="$noconfigdirs gas"
623fi
624
625# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
626# $target_configdirs.
627# If we have the source for $noconfigdirs entries, add them to $notsupp.
628
629notsupp=""
630for dir in . $skipdirs $noconfigdirs ; do
631 dirname=`echo $dir | sed -e s/target-//g`
632 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
633 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
634 if [ -r $srcdir/$dirname/configure ] \
635 || [ -r $srcdir/$dirname/configure.in ]; then
636 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
637 true
638 else
639 notsupp="$notsupp $dir"
640 fi
641 fi
642 fi
643 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
644 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
645 if [ -r $srcdir/$dirname/configure ] \
646 || [ -r $srcdir/$dirname/configure.in ]; then
647 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
648 true
649 else
650 notsupp="$notsupp $dir"
651 fi
652 fi
653 fi
654done
655
656# Sometimes the tools are distributed with libiberty but with no other
657# libraries. In that case, we don't want to build target-libiberty.
658if [ -n "${target_configdirs}" ]; then
659 others=
660 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
661 if [ "$i" != "libiberty" ]; then
662 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
663 others=yes;
664 break;
665 fi
666 fi
667 done
668 if [ -z "${others}" ]; then
669 target_configdirs=
670 fi
671fi
672
673# Deconfigure all subdirectories, in case we are changing the
674# configuration from one where a subdirectory is supported to one where it
675# is not.
676if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
677 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
678 rm -f $i/Makefile
679 done
680fi
681if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
682 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
683 rm -f ${target_subdir}/$i/Makefile
684 done
685fi
686
687# Produce a warning message for the subdirs we can't configure.
688# This isn't especially interesting in the Cygnus tree, but in the individual
689# FSF releases, it's important to let people know when their machine isn't
690# supported by the one or two programs in a package.
691
692if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
693 # If $appdirs is non-empty, at least one of those directories must still
694 # be configured, or we error out. (E.g., if the gas release supports a
695 # specified target in some subdirs but not the gas subdir, we shouldn't
696 # pretend that all is well.)
697 if [ -n "$appdirs" ]; then
698 for dir in $appdirs ; do
699 if [ -r $dir/Makefile.in ]; then
700 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
701 appdirs=""
702 break
703 fi
704 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
705 appdirs=""
706 break
707 fi
708 fi
709 done
710 if [ -n "$appdirs" ]; then
711 echo "*** This configuration is not supported by this package." 1>&2
712 exit 1
713 fi
714 fi
715 # Okay, some application will build, or we don't care to check. Still
716 # notify of subdirs not getting built.
717 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
718 echo " ${notsupp}" 1>&2
719 echo " (Any other directories should still work fine.)" 1>&2
720fi
721
722# Set with_gnu_as and with_gnu_ld as appropriate.
723#
724# This is done by determining whether or not the appropriate directory
725# is available, and by checking whether or not specific configurations
726# have requested that this magic not happen.
727#
728# The command line options always override the explicit settings in
729# configure.in, and the settings in configure.in override this magic.
730#
731# If the default for a toolchain is to use GNU as and ld, and you don't
732# want to do that, then you should use the --without-gnu-as and
733# --without-gnu-ld options for the configure script.
734
735if [ x${use_gnu_as} = x ] ; then
736 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
737 with_gnu_as=yes
738 withoptions="$withoptions --with-gnu-as"
739 fi
740fi
741
742if [ x${use_gnu_ld} = x ] ; then
743 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
744 with_gnu_ld=yes
745 withoptions="$withoptions --with-gnu-ld"
746 fi
747fi
748
749# If using newlib, add --with-newlib to the withoptions so that gcc/configure
750# can detect this case.
751
752if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
753 with_newlib=yes
754 withoptions="$withoptions --with-newlib"
755fi
756
757if [ x${shared} = xyes ]; then
758 case "${target}" in
759 hppa*) target_makefile_frag=config/mt-papic ;;
760 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
761 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
762 esac
763fi
764
765# post-target:
766
767# Make sure that the compiler is able to generate an executable. If it
768# can't, we are probably in trouble. We don't care whether we can run the
769# executable--we might be using a cross compiler--we only care whether it
770# can be created. At this point the main configure script has set CC.
771echo "int main () { return 0; }" > conftest.c
772${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
773if [ $? = 0 ] && [ -s conftest ]; then
774 :
775else
776 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
777 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
778 rm -f conftest*
779 exit 1
780fi
781rm -f conftest*
782
783# The Solaris /usr/ucb/cc compiler does not appear to work.
784case "${host}" in
785 sparc-sun-solaris2*)
786 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
787 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
788 could_use=
789 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
790 if [ -d /opt/cygnus/bin ] ; then
791 if [ "$could_use" = "" ] ; then
792 could_use="/opt/cygnus/bin"
793 else
794 could_use="$could_use or /opt/cygnus/bin"
795 fi
796 fi
797 if [ "$could_use" = "" ] ; then
798 echo "Warning: compilation may fail because you're using"
799 echo "/usr/ucb/cc. You should change your PATH or CC "
800 echo "variable and rerun configure."
801 else
802 echo "Warning: compilation may fail because you're using"
803 echo "/usr/ucb/cc, when you should use the C compiler from"
804 echo "$could_use. You should change your"
805 echo "PATH or CC variable and rerun configure."
806 fi
807 fi
808 ;;
809esac
810
811# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
812# binutils tools will find libbfd.so.
813if [ "${shared}" = "yes" ]; then
814 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
815 Makefile > Makefile.tem
816 rm -f Makefile
817 mv -f Makefile.tem Makefile
818
819 case "${host}" in
820 *-*-hpux*)
821 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
822 Makefile > Makefile.tem
823 rm -f Makefile
824 mv -f Makefile.tem Makefile
825 ;;
826 esac
827fi
828
829# Record target_configdirs and the configure arguments in Makefile.
830target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
831targargs=`echo "${arguments}" | \
832 sed -e 's/--norecursion//' \
833 -e 's/--cache[a-z-]*=[^ ]*//' \
834 -e 's/--ho[a-z-]*=[^ ]*//' \
835 -e 's/--ta[a-z-]*=[^ ]*//'`
836
837# Passing a --with-cross-host argument lets the target libraries know
838# whether they are being built with a cross-compiler or being built
839# native. However, it would be better to use other mechanisms to make the
840# sorts of decisions they want to make on this basis. Please consider
841# this option to be deprecated. FIXME.
842if [ x${is_cross_compiler} = xyes ]; then
843 targargs="--with-cross-host=${host_alias} ${targargs}"
844fi
845
846targargs="--host=${target_alias} ${targargs}"
847sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
848 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
849 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
850 Makefile > Makefile.tem
851rm -f Makefile
852mv -f Makefile.tem Makefile
853
854#
855# Local Variables:
856# fill-column: 131
857# End:
858#
This page took 0.034953 seconds and 4 git commands to generate.